// Binary Tree Header...
template <class T>
class TreeNode {
  public:
    T *data;
    TreeNode<T> *leftptr;
    TreeNode<T> *right;
    TreeNode() { leftptr=right=NULL; };
    TreeNode(const T &item) { // constructor
        data=new T(item);
        leftptr=right=NULL;
    }
};

template <class T>
class BinTreeClass {
  private:
     TreeNode<T> *root;
     void InsertItemHelper(TreeNode<T> *CurrNode, TreeNode<T> *ToBeInserted) {
          if (*(CurrNode->data) > *(ToBeInserted->data)) {
             if (CurrNode->leftptr == NULL) {
                 CurrNode->leftptr = ToBeInserted;
                 return;
	     }
             else InsertItemHelper(CurrNode->leftptr,ToBeInserted);
         }
         else {
             if (CurrNode->right == NULL) {
                 CurrNode->right = ToBeInserted;
                 return;
             }
             else InsertItemHelper(CurrNode->right,ToBeInserted); 
         }
      }

   public:
     BinTreeClass() { root=NULL;}
     BinTreeClass(T item) {
         root = new TreeNode<T>(item);
     }
     int CountNodes() {
	return CNodes(root);
     }
     int CNodes(TreeNode<T> *foo) {
         if (foo==NULL)
	   	return 0;
         else
	 	return 1+CNodes(foo->leftptr)+CNodes(foo->right);
	 }
      int Depth() {
	return dpth(root);
      }
      int dpth(TreeNode<T> *foo) {
	  if (foo==NULL)
	      return 0;
	  else {
	      if (dpth(foo->leftptr) > dpth(foo->right))
	          return 1+dpth(foo->leftptr);
              else
	          return 1+dpth(foo->right);
               }
      } 
      
     void Insert(T item) {
         TreeNode<T> *temp = new TreeNode<T>(item);
         if (root == NULL) {
            root = temp;
            return;
	 }
         else InsertItemHelper(root,temp);
     }
     int find (char *s, Student *array[]) {
	 int count = 0;    
         findhelper(s,root,array,count);
	 return count;
     }
     void findhelper(char *s, TreeNode<T> *foo, Student *array[], int &count) {
	 if (!strcmp(foo->data->getname(),s)) {
              if(count < 20) {
		  array[count] = new Student;
                  *array[count] = *(foo->data);
 	      }
	      count++;
         }
	 if (strcmp(foo->data->getname(),s)>0 && foo->leftptr)
		 findhelper(s,foo->leftptr,array,count);
	 else	
		if (foo->right)
	 		findhelper(s,foo->right,array,count);
     }
     void FirstTen() {
     	int count = 0;
	FTHelper(root,count);
     }
     void FTHelper (TreeNode<T> *foo, int &count) {
     	if (count < 10) {
		cout << *(foo->data) << '\t';
	}
	count ++;
	if (foo->leftptr)
	       FTHelper(foo->leftptr,count);
	if (foo->right)
	       FTHelper(foo->right,count);
     }
     ~BinTreeClass() {
     	destroy(root);
     }
     void destroy(TreeNode<T> *foo){
     	if(foo) {
		destroy(foo->leftptr);
		destroy(foo->right);
		//delete [] foo->data;
		delete foo;
	}
     }

};
